

namespace GWoffice.Services
{
	
	/**
	 * this menu will not actually be show since it's just an incomplete duplicate of the html menu.
	 * It will just be used for ubuntu's HUD.
	 **/
	public class HUD : Gtk.MenuBar
	{
		
		App app;
		
		public HUD (App _app)
		{
			app = _app;
			
			var file = new Gtk.MenuItem.with_label (_("File"));
			file.submenu = new Gtk.Menu ();
			var open = new Gtk.MenuItem.with_label (_("Open"));
			open.activate.connect (() => run_command ("open") );
			file.submenu.append (open);
			var revision_history = new Gtk.MenuItem.with_label (_("Revision History"));
			revision_history.activate.connect (() => run_command ("revision-history") );
			file.submenu.append (revision_history);
			var print = new Gtk.MenuItem.with_label (_("Print"));
			print.activate.connect (() => run_command ("print") );
			file.submenu.append (print);
			if (app.ubuntu_style) {
				file.submenu.append (new Gtk.SeparatorMenuItem ());
				
				var delete_login_data = new Gtk.MenuItem.with_label (_("Delete login data"));
				file.submenu.append (delete_login_data);
				delete_login_data.activate.connect (app.clear_saved_data);
				
				var show_prefs = new Gtk.MenuItem.with_label (_("Preferences"));
				file.submenu.append (show_prefs);
				show_prefs.activate.connect (() => {
					var p = new Widgets.Preferences (app);
					p.run ();
					p.destroy ();
				});
				
				file.submenu.append (new Gtk.SeparatorMenuItem ());
				
				var quit = new Gtk.MenuItem.with_label (_("Quit"));
				file.submenu.append (quit);
				quit.activate.connect (() => app.window.destroy () );
			}
			
			var edit = new Gtk.MenuItem.with_label (_("Edit"));
			edit.submenu = new Gtk.Menu ();
			var undo = new Gtk.MenuItem.with_label (_("Undo"));
			undo.activate.connect (() => run_command ("undo") );
			edit.submenu.append (undo);
			var redo = new Gtk.MenuItem.with_label (_("Redo"));
			redo.activate.connect (() => run_command ("redo") );
			edit.submenu.append (redo);
			var cut = new Gtk.MenuItem.with_label (_("Cut"));
			cut.activate.connect (() => run_command ("cut") );
			edit.submenu.append (cut);
			var copy = new Gtk.MenuItem.with_label (_("Copy"));
			copy.activate.connect (() => run_command ("copy") );
			edit.submenu.append (copy);
			var paste = new Gtk.MenuItem.with_label (_("paste"));
			paste.activate.connect (() => run_command ("paste") );
			edit.submenu.append (paste);
			var select_all = new Gtk.MenuItem.with_label (_("Select All"));
			select_all.activate.connect (() => run_command ("select-all") );
			edit.submenu.append (select_all);
			var find = new Gtk.MenuItem.with_label (_("Find"));
			find.activate.connect (() => run_command ("find") );
			edit.submenu.append (find);
			
			var view = new Gtk.MenuItem.with_label (_("View"));
			view.submenu = new Gtk.Menu ();
			var compact_controls = new Gtk.MenuItem.with_label (_("Compact Controls"));
			compact_controls.activate.connect (() => run_command ("compact-controls") );
			view.submenu.append (compact_controls);
			
			var insert = new Gtk.MenuItem.with_label (_("Insert"));
			insert.submenu = new Gtk.Menu ();
			var link = new Gtk.MenuItem.with_label (_("Link"));
			link.activate.connect (() => run_command ("link") );
			insert.submenu.append (link);
			var numbered_list = new Gtk.MenuItem.with_label (_("Numbered List"));
			numbered_list.activate.connect (() => run_command ("numbered-list") );
			insert.submenu.append (numbered_list);
			var bulleted_list = new Gtk.MenuItem.with_label (_("Bulleted List"));
			bulleted_list.activate.connect (() => run_command ("bulleted-list") );
			insert.submenu.append (bulleted_list);
			var comment = new Gtk.MenuItem.with_label (_("Comment"));
			comment.activate.connect (() => run_command ("comment") );
			insert.submenu.append (comment);
			var footnote = new Gtk.MenuItem.with_label (_("Footnote"));
			footnote.activate.connect (() => run_command ("footnote") );
			insert.submenu.append (footnote);
			var page_break = new Gtk.MenuItem.with_label (_("Page Break"));
			page_break.activate.connect (() => run_command ("page-break") );
			insert.submenu.append (page_break);
			
			var format = new Gtk.MenuItem.with_label (_("Format"));
			format.submenu = new Gtk.Menu ();
			var bold = new Gtk.MenuItem.with_label (_("Bold"));
			bold.activate.connect (() => run_command ("bold") );
			format.submenu.append (bold);
			var italic = new Gtk.MenuItem.with_label (_("Italic"));
			italic.activate.connect (() => run_command ("italic") );
			format.submenu.append (italic);
			var underline = new Gtk.MenuItem.with_label (_("Underline"));
			underline.activate.connect (() => run_command ("underline") );
			format.submenu.append (underline);
			var superscript = new Gtk.MenuItem.with_label (_("Superscript"));
			superscript.activate.connect (() => run_command ("superscript") );
			format.submenu.append (superscript);
			var subscript = new Gtk.MenuItem.with_label (_("Subscript"));
			subscript.activate.connect (() => run_command ("subscript") );
			format.submenu.append (subscript);
			var normal_text = new Gtk.MenuItem.with_label (_("Clear Formatting"));
			normal_text.activate.connect (() => run_command ("normal-text") );
			format.submenu.append (normal_text);
			
			var align = new Gtk.MenuItem.with_label (_("Align"));
			align.submenu = new Gtk.Menu ();
			format.submenu.append (align);
			var align_left = new Gtk.MenuItem.with_label (_("Left"));
			align_left.activate.connect (() => run_command ("align-left") );
			align.submenu.append (align_left);
			var align_center = new Gtk.MenuItem.with_label (_("Center"));
			align_center.activate.connect (() => run_command ("align-center") );
			align.submenu.append (align_center);
			var align_right = new Gtk.MenuItem.with_label (_("Right"));
			align_right.activate.connect (() => run_command ("align-right") );
			align.submenu.append (align_right);
			var align_justify = new Gtk.MenuItem.with_label (_("Justify"));
			align_justify.activate.connect (() => run_command ("align-justify") );
			align.submenu.append (align_justify);
			
			/*var clear_formatting = new Gtk.MenuItem.with_label (_("Clear Formatting"));
			clear_formatting.activate.connect (() => run_command ("clear-formatting") );
			format.submenu.append (clear_formatting);*/
			
			var tools = new Gtk.MenuItem.with_label (_("Tools"));
			tools.submenu = new Gtk.Menu ();
			var research = new Gtk.MenuItem.with_label (_("Research"));
			research.activate.connect (() => run_command ("research") );
			tools.submenu.append (research);
			var define = new Gtk.MenuItem.with_label (_("Define"));
			define.activate.connect (() => run_command ("define") );
			tools.submenu.append (define);
			var word_count = new Gtk.MenuItem.with_label (_("Word Count"));
			word_count.activate.connect (() => run_command ("word-count") );
			tools.submenu.append (word_count);
			
			append (file);
			append (edit);
			append (view);
			append (insert);
			append (format);
			append (tools);
			
			if (app.ubuntu_style) {
				var help = new Gtk.MenuItem.with_label (_("Help"));
				help.submenu = new Gtk.Menu ();
				var about = new Gtk.MenuItem.with_label (_("About"));
				help.submenu.append (about);
				
				about.activate.connect (() => {
					app.show_about (app.window);
				});
				
				append (help);
			}
		}
		
		/**
		 * run a shortcut on the webview. if webview is null, get the current
		 **/
		public void run_command (string command, Widgets.WebView? view=null)
		{
			if (view == null) {
				view = ((app.notebook.current.page as Gtk.ScrolledWindow).get_child () as Widgets.WebView);
			}
			
			var e = Gdk.EventKey ();
			
			bool alt = false;
			bool shift = false;
			
			switch (command)
			{
				//file
				case "open":e.str = "";e.keyval = 111;e.hardware_keycode = 32;break;
				case "revision-history":e.str = "";e.keyval = 103;e.hardware_keycode = 42;alt=true;break;
				case "print":e.str = "";e.keyval = 112;e.hardware_keycode = 33;break;
				//edit
				case "undo":e.str = "";e.keyval = 122;e.hardware_keycode = 29;break;
				case "redo":e.str = "";e.keyval = 121;e.hardware_keycode = 52;break;
				case "cut":e.str = "";e.keyval = 120;e.hardware_keycode = 53;break;
				case "copy":e.str = "";e.keyval = 99;e.hardware_keycode = 54;break;
				case "paste":e.str = "";e.keyval = 118;e.hardware_keycode = 55;break;
				case "select-all":e.str = "";e.keyval = 97;e.hardware_keycode = 38;break;
				case "find":e.str = "";e.keyval = 102;e.hardware_keycode = 41;break;
				//view
				case "compact-controls":e.str = "";e.keyval = 70;e.hardware_keycode = 41;shift=true;break;
				//insert
				case "link":e.str = "";e.keyval = 107;e.hardware_keycode = 45;break;
				case "numbered-list":e.str = "";e.keyval = 47; e.hardware_keycode = 16;shift=true;break;
				case "bulleted-list":e.str = "(";e.keyval = 40;e.hardware_keycode = 17;shift=true;break;
				case "comment":e.str = "";e.keyval = 109;e.hardware_keycode = 58;alt=true;break;
				case "footnote":e.str = "";e.keyval = 102;e.hardware_keycode = 41;alt=true;break;
				case "page-break":e.str = "";e.keyval = 65293;e.hardware_keycode = 36;break;
				//format
				case "bold":e.str = "";e.keyval = 98;e.hardware_keycode = 56;break;
				case "italic":e.str = "	";e.keyval = 105;e.hardware_keycode = 31;break;
				case "underline":e.str = "";e.keyval = 117;e.hardware_keycode = 30;break;
				case "superscript":e.str = ".";e.keyval = 46;e.hardware_keycode = 60;break;
				case "subscript":e.str = ",";e.keyval = 44;e.hardware_keycode = 59;break;
				case "normal-text":e.str = "0";e.keyval = 48;e.hardware_keycode = 19;alt=true;break;
				case "align-left":e.str = "";e.keyval = 76;e.hardware_keycode = 46;shift=true;break;
				case "align-center":e.str = "";e.keyval = 69;e.hardware_keycode = 26;shift=true;break;
				case "align-right":e.str = "";e.keyval = 82;e.hardware_keycode = 27;shift=true;break;
				case "align-justify":e.str = "";e.keyval = 74;e.hardware_keycode = 44;shift=true;break;
				/*case "clear-formatting":e.str = "";e.keyval = 47;e.hardware_keycode = 16;break;*/
				//tools
				case "research":e.str = "";e.keyval = 114;e.hardware_keycode = 27;alt=true;break;
				case "define":e.str = "";e.keyval = 89;e.hardware_keycode = 52;shift=true;break;
				case "word-count":e.str = "";e.keyval = 67;e.hardware_keycode = 54;shift=true;break;
				default:return;
			}
			
			e.type = Gdk.EventType.KEY_PRESS;
			e.window = view.get_window ();
			e.send_event = 0;
			e.time = Gtk.get_current_event_time ();
			e.state = Gdk.ModifierType.CONTROL_MASK;
			if (shift)
				e.state |= Gdk.ModifierType.SHIFT_MASK;
			if (alt)
				e.state |= Gdk.ModifierType.MOD1_MASK;
			e.length = 1;
			e.group = 0;
			e.is_modifier = 0;
			
			view.key_press_event (e);
		}
	}
}

