using GData;


namespace GWoffice.Widgets
{
	
	
	public class AccessPopOver : GWoffice.Widgets.PopOver {
		
		DocumentsEntry entry;
		DocumentsService docs;
		
		public AccessPopOver (DocumentsEntry _entry, DocumentsService _docs)
		{
			entry = _entry;
			docs = _docs;
			
			height_request = 200;
			width_request = 300;
			
			var spinner = new Gtk.Spinner ();
			(get_content_area () as Gtk.Container).add (spinner);
			spinner.start ();
			spinner.margin_top = 25;
			spinner.height_request = 48;
			spinner.width_request = 48;
			spinner.halign = spinner.valign = Gtk.Align.CENTER;
			
			
			var list = new Gtk.Grid ();
			list.row_spacing = 6;
			list.column_spacing = 12;
			list.margin = 12;
			
			list.attach (new LLabel.markup ("<b>"+_("Last Modifier")+"</b>"), 0, 0, 1, 1);
			list.attach (new LLabel (entry.last_modified_by.name+" ("+entry.last_modified_by.email_address+")"), 1, 0, 1, 1);
			list.attach (new LLabel.markup ("<b>"+_("Last Viewed")+"</b>"), 0, 1, 1, 1);
			list.attach (new LLabel (new DateTime.from_unix_local (entry.last_viewed).format ("%c")), 1, 1, 1, 1);
			list.attach (new LLabel.markup ("<b>"+_("Access")+"</b>"), 0, 2, 2, 1);
			
			var row = 3;
			
			entry.get_rules_async.begin (docs, null, (entry, key, count) => {
				var access = entry as AccessRule;
				
				//list.attach (new Gtk.Image.from_stock (Gtk.Stock.CLOSE, Gtk.IconSize.MENU), 0, row, 1, 1);
				list.attach (new LLabel (access.role), 0, row, 1, 1);
				list.attach (new LLabel (access.scope_value), 1, row, 1, 1);
				
				row ++;
				
			}, (val, res) => { //once we got everything together
				(get_content_area ()).remove (spinner);
				(get_content_area () as Gtk.Container).add (list);
				
				get_content_area ().show_all ();
			});
			
			
			
		}
		
		
	}
	
	
}

